----------------------------------------------------------------------------------
-- UART controller test bench
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity UART_controller_tb is
--  Port ( );
end entity;

architecture Behavioral of UART_controller_tb is
    constant clk_period : time := 10 ns;    
    signal CLK100MHZ, BTNC, CPU_RESETN, UART_RXD_OUT : std_logic;
    
begin
    uut: entity work.UART_controller(Behavioral)
    port map(
        CLK100MHZ => CLK100MHZ,
        CPU_RESETN => CPU_RESETN,
        BTNC => BTNC,
        UART_RXD_OUT => UART_RXD_OUT
    ); 
    
    stimulus_clk: process
    begin 
        CLK100MHZ <= '0';
        wait for clk_period/2;
        CLK100MHZ <= '1';
        wait for clk_period/2;    
    end process;
    
    stimuli: process 
    begin 
    
        -- Leave circuit uninitialized 
        wait for clk_period*3;
        
        -- Assert external inputs 
        BTNC <= '0';
        CPU_RESETN <= '1';
        wait for clk_period*3;
        
        -- Press BNTC to start the transmission 
        BTNC <= '1';
        wait for 200 us;
        
        -- Reset        
        BTNC <= '0';
        CPU_RESETN <= '0';
        wait for clk_period*3;
        
        -- Remove reset
        CPU_RESETN <= '1';
        wait for clk_period*3;
        -- Press BNTC to start the transmission  
        BTNC <= '1';
        wait;
        
    end process;

end Behavioral;
